#pragma once

#include	"stdThread.h"
#include	"MySyncObject.h"

// ވʒu lTail
// ǂݏoʒu lHead
// lHead = lTail̎̓obt@ɉĂȂƒ`
// 0----Head-----Tail-----AllocSize  size:T-H
// 0----Tail-----Haed-----AllocSize  size:(A-H) + T

class CRingBuff
{
public:
	CRingBuff(long lMaxSize, BOOL fUseLock = FALSE);
	~CRingBuff(void);

	long		Read(LPBYTE pbBuf, long lSize = 1);
	long		ReadWithoutUpdateHeadPoint(LPBYTE pbBuf, long lSize = 1);
	void		UpdateHeadPoint(long lSize = 1);
	long		Write(LPBYTE pbBuf, long lSize = 1);
	long		GetReadableSize();
	long		GetWriteableSize();
	void		Clear();

	BOOL		m_fInitialized;			// ł

private:
	LPBYTE		m_pbData;				// obt@̎
	long		m_lMaxSize;				// obt@̍őTCY
	long		m_lAllocSize;			// ̂̊mۃTCY=obt@̍őTCY+1
	long		m_lHead;				// ǂݍ݊Jnʒu
	long		m_lTail;				// ݊Jnʒu
	BOOL		m_fUseLock;				// gp邩
	CMySyncObject *m_pCMySyncObject;	// p

};


