#pragma once
#include "ThreadJob.h"

// ڑ\
typedef struct
{
	SOCKET			fdClient;				// ڑς݃\Pbg(connecť)
	BYTE			bMethod;				// TRANS_METHOD_TCP/TRANS_METHOD_UDP	
	SOCKET			fdUDP;					// UDPPbg(UDPgp)/INVALID_SOCKET
	sockaddr		*ai_addr;				// ڑAhX(UDP̑MƂĎgp)
	size_t			ai_addrlen;				// ڑAhX
} ConnectionInfoRec;

class CRingBuff;
class CQueingArray;							//
class CSendFileThread;
class CRecvFileThread;
class CMySyncObject;

class CSendRecvThread :
    public CThreadJob
{
public:
	CSendRecvThread(ConnectionInfoRec *pConInfo);	// p[^RXgN^œn
	~CSendRecvThread();

	// NX̊֐I[o[Ch
	// C++11ŖIoverrideƂo悤ɂȂ܂
	// NX̓Y֐virtualĂȂƃG[oĂ܂
	UINT DoWork() override;							// DoSendŎ{ĂeLq
	BOOL SetSendData(char* pcData, int iSize, BOOL fForceTCP = FALSE);	// Mf[^̐ݒ Rg[pɋITCPőM@\ǉ
	int GetRecvData(char** ppcData, int iTcpUdp);						// Mf[^̎擾(TCP/UDPŎQƃobt@؂ւ) 
	BOOL IsZombie();								// ̃Xbh̓]rԂ
	BOOL SendFile(LPSTR pszFileName);				// t@CM̎s@main()Ă΂
	BOOL SendFileAbort();							// t@CM̒f
	BOOL RecvFile(LPSTR pszFileName);				// t@CM̎s
	BOOL RecvFileAbort();							// t@CM̒f

private:
	ConnectionInfoRec *m_pConInfo;					// RXgN^œnp[^i[
													// ̃Xbhs̈悪mۂĂ邱
	BOOL m_fIamZombie;								// ]rԂǂێ

	CQueingArray* m_pCQueingArraySend;				// Mf[^i[pobt@(TCP)
	CRingBuff* m_pCRingBuffRecv;					// Mf[^i[pOobt@(TCP)
	CQueingArray* m_pCQueingArraySendUDP;			// Mf[^i[pobt@(UDP)ӂ
	CRingBuff* m_pCRingBuffRecvUDP;					// Mf[^i[pOobt@(UDP)

	sockaddr_storage m_PeerAddr;					// (UDPMp) IPAhX,|[gԍ
	socklen_t	m_iPeerAddrLen;						// ̒

	CSendFileThread* m_pCSendFileThread;			// t@CMXbh͕KvȎɍ쐬svɂȂΔj
	CRecvFileThread* m_pCRecvFileThread;			// t@CMXbh͕KvȎɍ쐬svɂȂΔj

	CMySyncObject* m_pCMySyncObjectSendWrite;		// Mobt@ւ̏ݓp

	DWORD	m_dwPrevSentTime;						// O񑗐M(msec)
	int		m_iSendInterval;						// 񑗐M܂ł̊Ԋu(msec)
	DWORD	m_dwPrevSentTimeUDP;					// O񑗐M(msec)UDP
	int		m_iSendIntervalUDP;						// 񑗐M܂ł̊Ԋu(msec)UDP

	int GetSendData(char** ppcData, int iTcpUdp);				// ML[f[^o(TCP/UDPŎQƃobt@؂ւ) 
	BOOL SetRecvData(char* pcData, int iSize, int iTcpUdp);		// Mf[^̐ݒ(TCP/UDPŎQƃobt@؂ւ)

	// DoWork()GɂȂȂ悤ɋ@\𕪂
	BOOL RecvTCPData(fd_set &rfds);								// TCPM
	BOOL RecvUDPData(fd_set &rfds);								// UDPM
	BOOL SendTCPData(fd_set &wfds, DWORD dwNow);				// TCPM ML[f[^ođM
	BOOL SendUDPData(fd_set &wfds, DWORD dwNow);				// UDPM ML[f[^ođM

	int AnalyzeRecvData(int iTcpUdp);							// Mf[^̉(pPbĝ҂)(TCP/UDPŎQƃobt@؂ւ)

	int SetMessagePacket(LPBYTE pbPacketData, int iPacketSize);		// `bgpPbg̏
	int SetSendFilePacket(LPBYTE pbPacketData, int iPacketSize);	// 
	int SetRecvFilePacket(LPBYTE pbPacketData, int iPacketSize);	// 
	BOOL SetTransMethodPacket(LPBYTE pbPacketData, int iPacketSize);// f[^M@pPbgM
	BOOL MakePeerUDPSockaddr(WORD wPeerPort);						// UDPʐMpɑsockaddr(|[gԍt^)

	BOOL KillSendFileThread();						// svɂȂ(Zombie)t@CMXbhj
	BOOL KillRecvFileThread();						// svɂȂ(Zombie)t@CMXbhj

	int CalcNextSendInterval(int iSentSize);		// 񑗐M܂ł̊Ԋu
	BOOL CanSendNow(DWORD dwNow, int iTcpUdp);		// MėǂɂȂ(TCP/UDPŎQƕϐ؂ւ)
};

