#pragma once

#include	"stdThread.h"

#define		MAGIC_DATA_LEN		36
#define		MAGIC_STRING		"E2E6F7BF-42B1-4382-AF0B-1F452ED13EB6"

#define		TIMEOUT_FOR_RES			(10000)	// ܂ł̃^CAEgmsec
//-----------------------------------------------------------------------
// `bg̃R}h
// Client->Server, Server->Client
#define		CMD_MSG_DATA			100
//-----------------------------------------------------------------------
// t@CMR}h v/
// Client->Server(REQ̂RES҂)
#define		CMD_SEND_FILE_START_REQ	200		// MJnv
#define		CMD_SEND_FILE_ING		201		// t@CM
#define		CMD_SEND_FILE_END_REQ	202		// Mv
#define		CMD_SEND_FILE_ABORT_REQ	203		// fv

// Server->Client
#define		CMD_SEND_FILE_START_RES	1200	// MJnvɑ΂鉞
#define		CMD_SEND_FILE_END_RES	1202	// Mvɑ΂鉞
#define		CMD_SEND_FILE_ABORT_RES	1203	// fvɑ΂鉞
//-----------------------------------------------------------------------
// t@CMR}h v/
// Client->Server
#define		CMD_RECV_FILE_SIZE_REQ	300		// MTCYv
#define		CMD_RECV_FILE_START_REQ	301		// MJnv
#define		CMD_RECV_FILE_END_RES	1303	// Mvɑ΂鉞
#define		CMD_RECV_FILE_ABORT_REQ	304		// fv

// Server->Client
#define		CMD_RECV_FILE_SIZE_RES	1300	// MTCYvɑ΂鉞
#define		CMD_RECV_FILE_ABORT_RES	1304	// fvɑ΂鉞
#define		CMD_RECV_FILE_ING		302		// t@CM
#define		CMD_RECV_FILE_END_REQ	303		// Mv
//-----------------------------------------------------------------------
// f[^M@R}h v/
// Client->Server
#define		CTRL_TRANS_METHOD_REQ	400		// f[^M@v(TCP/UDP)
#define		CTRL_SEND_NAT_TRANS_REQ	401		// NATẑ߂̃_~[f[^Mv

// Server->Client
#define		CTRL_TRANS_METHOD_RES	1400	// f[^M@(TCP/UDP)
#define		CTRL_SEND_NAT_TRANS_RES	1401	// NATẑ߂̃_~[f[^M(ŃT[o[NATe[uł)
//-----------------------------------------------------------------------


// Error Code
#define		ERR_SUCCESS				1		// 
#define		ERR_SEQUENCE			(-1)	// ԑJڃG[
#define		ERR_FILE_OPEN			(-2)	// t@CI[vG[
#define		ERR_FILE_SEEK			(-3)	// t@CV[NG[
#define		ERR_FILE_WRITE			(-4)	// t@C݃G[
#define		ERR_FILE_NOT_EXIST		(-5)	// t@C݂Ȃ

#pragma pack(push ,1)				// 1oCgEŃf[^zu
//==================================================
// ʃwb_
typedef struct
{
	BYTE	bMagicData[MAGIC_DATA_LEN];		// ȈՕsANZXh~@\p(WindowsGUIDg܂)
	WORD	wCommand;						// lbg[NI[_[ f[^̎
	WORD	wDataLen;						// lbg[NI[_[(wb_܂܂Ȃf[^)
} HeaderRec;

//==================================================
// bZ[WMppPbg ʃwb_ + f[^
// UserInfoRecg(NAԍȂǂǉĂʔ)
typedef struct
{
	char	szUserName[81];								// UserName UTF-8(null^[~l[g)
} UserInfoRec;

typedef struct
{
	HeaderRec	header;
	UserInfoRec	UserInfo;
	BYTE		bMsgData[1];							// null^[~lCg܂܂Ȃf[^
} MsgDataRec;

//==================================================
// t@CppPbgQ
//==================================================
#define		FILE_NAME_LEN		256				// tH_܂܂Ȃ(ΏۂƂ̂̓JgfBNgɂt@C)
#define		FILE_SIZE_DIGIT		10				// t@C͕ɂ܂(long͈̔ 2GByte)
//------------------------------
// f[^
//	t@CMJnv
//	t@CMTCYv		TCY0őM
//	t@CMJnv
//------------------------------
typedef struct
{
	char	szFileSize[FILE_SIZE_DIGIT + 1];	// t@C(null^[~l[g܂)
	char	szFileName[FILE_NAME_LEN + 1];		// t@C(null^[~l[g܂)UTF-8
} FileInfoRec;

typedef struct
{
	HeaderRec	header;
	FileInfoRec	FileInfo;
} SendFileStartReqRec, RecvFileSizeReqRec, RecvFileStartReqRec;


//------------------------------
// f[^
//	t@CM(t@C̓rAŌ)
//	t@CM(t@C̓rAŌ)
//------------------------------
typedef struct
{
	char	szOffset[FILE_SIZE_DIGIT + 1];
	char	szSize[FILE_SIZE_DIGIT + 1];
} SendFileStatRec;

typedef struct
{
	HeaderRec		header;
	SendFileStatRec	Stat;
	BYTE		bData[1];
} SendFileIngRec, SendFileEndReqRec, RecvFileIngRec, RecvFileEndReqRec;

//------------------------------
// f[^ t@CMfv
//	t@CMfv
//	t@CMfv
//------------------------------
typedef struct
{
	HeaderRec	header;
} SendFileAbortReqRec, RecvFileAbortReqRec;

//------------------------------
// f[^
//	t@CMvɑ΂鉞
//	t@CMvɑ΂鉞
//------------------------------
typedef struct
{
	HeaderRec	header;
	BYTE		bStatus;						// 1: -XX:s
} SendFileResRec, RecvFileResRec;

//------------------------------
// f[^
//	t@CMTCYv	t@CTCYɒl
//------------------------------
typedef struct
{
	HeaderRec	header;
	BYTE		bStatus;						// 1: -XX:s
	FileInfoRec	FileInfo;
} RecvFileSizeResRec;

//==================================================
// f[^@f[^]@ v
#define		TRANS_METHOD_TCP		0
#define		TRANS_METHOD_UDP		1
typedef struct
{
	BYTE	bMethod;								// TRANS_METHOD_TCP/TRANS_METHOD_UDP
	WORD	wUDPSrcPort;							// :UDPServer|[gԍ v:NCAg|[gԍ
} TransMethodInfoRec;

// pPbg f[^]@ v
// ClientUDPvoAServer牞TCPȂTCPŃf[^]s
// Server̉UDPȂԂĂ|[gԍNCAg͑MƂĎgp
typedef struct
{
	HeaderRec			header;
	TransMethodInfoRec	TansMethodInfo;
} TransMethodReqRec, TransMethodResRec;

//==================================================
// NATẑ߂UDPŃ_~[̃pPbg̑Mv/
typedef struct
{
	HeaderRec			header;
} NATTransMethodReqRec, NATTransMethodResRec;
//==================================================

#pragma pack(pop)				// EƂɖ߂
