#pragma once
#include "ThreadJob.h"
#include "define.h"				// pPbg쐬̂

// t@CMJڏ
#define SEND_FILE_STAT_IDLE				0		// 
#define SEND_FILE_STAT_STARTING			1		// t@CMJnv҂
#define SEND_FILE_STAT_ING				2		// t@CM
#define SEND_FILE_STAT_ENDING			3		// t@CMv҂
#define SEND_FILE_STAT_END				4		// t@CM
#define SEND_FILE_STAT_ABORT			5		// t@CMfvM
#define SEND_FILE_STAT_ABORTING			6		// t@CMfv҂
#define SEND_FILE_STAT_ABORTED			7		// t@CMf

class CSendRecvThread;			// CSendRecvThreadg
class CQueingArray;				// CQueingArrayg

class CSendFileThread :
    public CThreadJob
{
public:
	CSendFileThread(CSendRecvThread* pCSendRecvThread, LPSTR pszFileName);
	~CSendFileThread();

	UINT DoWork() override;
	BOOL IsZombie();											// ̃Xbh̓]rԂ
	BOOL SendFileAbort();										// t@CM̒f

	CQueingArray* m_pCQueingArrayCmd;							// t@CMR}hpPbgi[obt@

private:
	LPSTR m_pszFileName;
	CSendRecvThread* m_pCSendRecvThread;
	BOOL m_fIamZombie;											// ]rԂ

	int m_iSendFileStatus;										// t@CMJڏ
	BYTE m_bStartRes;											// Jnv(0:l/ErrorCode)
	BYTE m_bEndRes;												// v(0:l/ErrorCode)
	BYTE m_bAbortRes;											// fv(0:l/ErrorCode)

	DWORD m_dwSendReqTime;										// vs(^CAEĝ)
	long m_lTotalSize;											// Mt@Cf[^TCY̍v

	int DoSequence(int fdSrcFile, long lFileLength);			// JڏԂɑΉs
	int AnalyzeCmd();											// MR}h̉
	// DoSequence()Ăяo֐
	BOOL SendStartPacket(LPSTR pszFileName, int iFileLength);	// t@CMJnvM
	int CheckStartRes(DWORD dwTimeOut);							// t@CMJnv`FbN
	int SendIngEndPacket(int fd, int iFileLength);				// t@CrAt@CMvM
	int CheckEndRes(DWORD dwTimeOut);							// t@CMv`FbN
	BOOL SendAbortPacket();										// t@CMfvM
	int CheckAbortRes(DWORD dwTimeOut);							// t@CMfv`FbN
};

