#include "SendRecvThread.h"
#include "RingBuff.h"
#include "define.h"
#include "SendFileThread.h"					// CSendFileThreadg
#include "RecvFileThread.h"					// CRecvFileThreadg
#include "QueingArray.h"					// CQueingArrayg
#include "MySyncObject.h"

#define SEND_BUFF_QUE_SIZE	5				// Mobt@ƂĊmۂL[̐
#define	RECV_BUFF_SIZE		(1024 * 64)		// MOobt@̃TCY
#define RCVBUFSIZE			(1024 * 11)		// xTCP/UDPMobt@ǂލőTCY(f[^O̍őlȏ)
// Mx
#define	SEND_BPS			(1000000.0)		// Mx1Mbps ̃vOł5Mbps܂Őł͂

extern BOOL DestroySocket(SOCKET& fd);		// UDP\Pbg̔j(UDP->TCPɐ؂ւ)gp

//----------------------------------------------
// function
//    RXgN^
// parameter
//    ConnectionInfoRec *pConInfo	[in]@\ɕKvȏ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::CSendRecvThread(ConnectionInfoRec *pConInfo)
{
	m_pConInfo = pConInfo;
	m_fIamZombie = FALSE;

	m_pCQueingArraySend = new CQueingArray(SEND_BUFF_QUE_SIZE);		// Mobt@(TCP)
	m_pCRingBuffRecv = new CRingBuff(RECV_BUFF_SIZE);				// MOobt@(TCP)
	m_pCQueingArraySendUDP = new CQueingArray(SEND_BUFF_QUE_SIZE);	// Mobt@(UDP)
	m_pCRingBuffRecvUDP = new CRingBuff(RECV_BUFF_SIZE);			// MOobt@(UDP)

	m_pCMySyncObjectSendWrite = new CMySyncObject();
	m_pCMySyncObjectSendWrite->Initialize();

	m_pCSendFileThread = NULL;							// t@CM{Xbh
	m_pCRecvFileThread = NULL;							// t@CM{Xbh

	m_dwPrevSentTime = 0;								// 񑗐M͂(TCP)
	m_iSendInterval = 0;								// 
	m_dwPrevSentTimeUDP = 0;							// 񑗐M͂(UDP)
	m_iSendIntervalUDP = 0;								// 

	// ̏o(|[gTCP̐ڑŎgp̂Ȃ̂UDPgpɕύXKv T[ỏgp)
	m_iPeerAddrLen = (socklen_t)m_pConInfo->ai_addrlen;
	memcpy(&m_PeerAddr, m_pConInfo->ai_addr, m_iPeerAddrLen);
}

//----------------------------------------------
// function
//    fXgN^
// parameter
//    Ȃ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::~CSendRecvThread()
{
	if (m_pCSendFileThread != NULL)					// ĂĂ~߂(fKvł傤)
	{
		m_pCSendFileThread->End();
		m_pCSendFileThread->WaitForEnd();
	}
	SAFE_DELETE(m_pCSendFileThread)
	if (m_pCRecvFileThread != NULL)					// Ă~߂(fKvł傤)
	{
		m_pCRecvFileThread->End();
		m_pCRecvFileThread->WaitForEnd();
	}
	SAFE_DELETE(m_pCRecvFileThread)
	
	// ̔pɎ~߂
	SAFE_DELETE(m_pCQueingArraySend)				// Mobt@̔j(TCP)
	SAFE_DELETE(m_pCRingBuffRecv)					// MOobt@̔j(TCP)
	SAFE_DELETE(m_pCQueingArraySendUDP)				// Mobt@̔j(UDP)
	SAFE_DELETE(m_pCRingBuffRecvUDP)				// MOobt@̔j(UDP)
	m_pCMySyncObjectSendWrite->Uninitialize();
	SAFE_DELETE(m_pCMySyncObjectSendWrite)
}

//----------------------------------------------
// function
//    @\Lq֐(DoSendɋLqĂeLq)
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
UINT CSendRecvThread::DoWork()
{
	BOOL		fRet = TRUE;
	fd_set		wfds, rfds;
	timeval   	tv;
	int			iSendQueSizeTCP = 0;	// Mf[^i[ĂL[̐@TCP
	int			iSendQueSizeUDP = 0;	// Mf[^i[ĂL[̐ UDP
	DWORD		dwNow;					// M`FbNo邽

	while (!m_fStopFlag)
	{
		KillSendFileThread();			// t@CMIĂXbhj
		KillRecvFileThread();			// t@CMIĂXbhj

		// TCPM̃f[^ȂΑMf[^邩ׂ
		iSendQueSizeTCP = m_pCQueingArraySend->GetSize();
		// UDPM̃f[^ȂΑMf[^邩ׂ
		if (m_pConInfo->bMethod == TRANS_METHOD_UDP)
		{
			if (iSendQueSizeUDP == 0)
				iSendQueSizeUDP = m_pCQueingArraySendUDP->GetSize();
		}

		tv.tv_sec = 0;
		tv.tv_usec = 10 * 1000;							// 10msec
		FD_ZERO(&wfds);
		FD_ZERO(&rfds);

		// M\Mf[^ƂM\pfd_setɃZbg
		// `FbN̂߂Ɍݎ擾
		timeBeginPeriod(1);			// ^C}[̍ŏx1msecɂ
		dwNow = timeGetTime();
		timeEndPeriod(1);			// ^C}[̍ŏx߂

		// M̌͏ɍs
		FD_SET(m_pConInfo->fdClient, &rfds);

		if ((iSendQueSizeTCP > 0) && (CanSendNow(dwNow, TRANS_METHOD_TCP) == TRUE))
			FD_SET(m_pConInfo->fdClient, &wfds);

		if (m_pConInfo->bMethod == TRANS_METHOD_UDP)
		{
			// M͏ɌΏ
			FD_SET(m_pConInfo->fdUDP, &rfds);
			if ((iSendQueSizeUDP > 0) && (CanSendNow(dwNow, TRANS_METHOD_UDP) == TRUE))
				FD_SET(m_pConInfo->fdUDP, &wfds);
		}
		select(FD_SETSIZE, &rfds, &wfds, NULL, &tv);	// ^CAEg܂SleepƓ

		// MTCP
		if ((fRet = RecvTCPData(rfds)) == FALSE)
			break;
		// MUDP
		if ((fRet = RecvUDPData(rfds)) == FALSE)
			break;

		// MTCP
		if ((fRet = SendTCPData(wfds, dwNow)) == FALSE)
			break;
		else
			iSendQueSizeTCP = 0;
		// MUDP
		if ((fRet = SendUDPData(wfds, dwNow)) == FALSE)
			break;
		else
			iSendQueSizeUDP = 0;

		// Mf[^̉TCP
		if (AnalyzeRecvData(TRANS_METHOD_TCP) == -1)	// G[͏I
		{
			DispNetErrorMsg("Err:Packet format TCP");
			fRet = FALSE;
			break;
		}
		// Mf[^̉UDP
		if (AnalyzeRecvData(TRANS_METHOD_UDP) == -1)	// G[͏I
		{
			DispNetErrorMsg("Err:Packet format UDP");
			fRet = FALSE;
			break;
		}
	}
	m_fIamZombie = TRUE;
	return((fRet == TRUE) ? 0 : -1);
}

//----------------------------------------------
// function
//		TCP̎M
//		MOobt@Ɋi[
// parameter
//		fd_set &rfds	[in]
// return
//		TRUE/FALSE:ؒf/G[
//----------------------------------------------
BOOL CSendRecvThread::RecvTCPData(fd_set &rfds)
{
	BOOL	fRet = TRUE;
	char	szRecvBuffer[RCVBUFSIZE + 1];
	int		iRecvSize;

	if (FD_ISSET(m_pConInfo->fdClient, &rfds))		// Mf[^recv{
	{
		// MOobt@ɋ󂫂ΎM
		// ŎMȂ΁ǍŎMs
		iRecvSize = min(m_pCRingBuffRecv->GetWriteableSize(), RCVBUFSIZE);
		if (iRecvSize > 0)
		{
			if ((iRecvSize = recv(m_pConInfo->fdClient, szRecvBuffer, iRecvSize, 0)) > 0)
			{
				fprintf(stderr, "Recv by TCP Size:%d ", iRecvSize);
				// 擾f[^ɎMOobt@ɏ
				// MOobt@ɏނ̂͂̃XbhȂ̂ŁAׂď߂͂
				SetRecvData(szRecvBuffer, iRecvSize, TRANS_METHOD_TCP);
			}
			else
			{
				if (iRecvSize == 0)							// 0oCg̎M͐ؒfm@-1̓G[
					DispNetErrorMsg("Disconnected");
				else
					DispNetErrorMsg("Err:recv");
				fRet = FALSE;
			}
		}
	}
	return(fRet);
}


//----------------------------------------------
// function
//		UDP̎M
//		MOobt@Ɋi[
// parameter
//		fd_set &rfds	[in]
// return
//		TRUE/FALSE:ؒf/G[
//----------------------------------------------
BOOL CSendRecvThread::RecvUDPData(fd_set &rfds)
{
	BOOL	fRet = TRUE;
	char	szRecvBuffer[RCVBUFSIZE + 1];	// Mobt@
	int		iRecvSize;
	sockaddr_storage	PeerAddr;			// MAhX
	socklen_t			iPeerLen;

	if (FD_ISSET(m_pConInfo->fdUDP, &rfds))		// Mf[^recvfrom{
	{
		// UDPł̓pPbgTCY菬TCYŎMƎc͔j
		// ŎMȂ΁ǍŎMs
		if (m_pCRingBuffRecvUDP->GetWriteableSize() > RCVBUFSIZE)
		{
			iPeerLen = sizeof(PeerAddr);	// MAhXi[\̂̃TCY
			if ((iRecvSize = recvfrom(m_pConInfo->fdUDP, szRecvBuffer, RCVBUFSIZE, 0, (sockaddr*)&PeerAddr, &iPeerLen)) < 0)
			{
				DispNetErrorMsg("Err:recvfrom");
				fRet = FALSE;
			}
			else
			{
				// mF̂߂ɑ\
				char	szPort[NI_MAXSERV], szAddr[NI_MAXHOST];
				getnameinfo((sockaddr*)&PeerAddr, iPeerLen, szAddr, sizeof(szAddr), szPort, sizeof(szPort), NI_NUMERICHOST | NI_NUMERICSERV);
				fprintf(stderr, "Recv by UDP:%s %s Size:%d ", szAddr, szPort, iRecvSize);
				// 擾f[^ɎMOobt@ɏ
				// MOobt@ɏނ̂͂̃XbhȂ̂ŁAׂď߂͂
				SetRecvData(szRecvBuffer, iRecvSize, TRANS_METHOD_UDP);
			}
		}
	}
	return(fRet);
}

//----------------------------------------------
// function
//		TCP̑M
//		ML[1L[f[^ođM
// parameter
//		fd_set	&wfds		[in]
//		DWORD	dwNow		[in]ݎ
// return
//		TRUE/FALSE:ؒf/G[
//----------------------------------------------
BOOL CSendRecvThread::SendTCPData(fd_set &wfds, DWORD dwNow)
{
	BOOL	fRet = TRUE;
	char	*pcData = NULL;						// Mf[^
	int		iSendSize;							// Mf[^TCY

	if (FD_ISSET(m_pConInfo->fdClient, &wfds))	// M\Ȃsend{
	{
		// Mf[^̎擾
		iSendSize = GetSendData(&pcData, TRANS_METHOD_TCP);
		fprintf(stderr, "Send by TCP Size:%d ", iSendSize);
		if (send(m_pConInfo->fdClient, pcData, iSendSize, 0) != iSendSize)
		{
			DispNetErrorMsg("Err:send");
			fRet = FALSE;
		}
		SAFE_FREE(pcData)
		// MƎ񑗐M܂ł̎ԂZbg
		m_dwPrevSentTime = dwNow;
		m_iSendInterval = CalcNextSendInterval(iSendSize);
	}
	return(fRet);
}

//----------------------------------------------
// function
//		UDP̑M
//		ML[1L[f[^ođM
// parameter
//		fd_set		&wfds		[in]
//		DWORD		dwNow		[in]ݎ
// return
//		TRUE
//----------------------------------------------
BOOL CSendRecvThread::SendUDPData(fd_set &wfds, DWORD dwNow)
{
	BOOL	fRet = TRUE;
	char	*pcData = NULL;				// Mf[^
	int		iSendSize;					// Mf[^TCY

	// M
	if (FD_ISSET(m_pConInfo->fdUDP, &wfds))	// M\Ȃsendto{
	{
		// Mf[^̎擾
		iSendSize = GetSendData(&pcData, TRANS_METHOD_UDP);
		// mF̂߂ɑ\
		char	szPort[NI_MAXSERV], szAddr[NI_MAXHOST];
		getnameinfo((sockaddr*)&m_PeerAddr, m_iPeerAddrLen, szAddr, sizeof(szAddr), szPort, sizeof(szPort), NI_NUMERICHOST | NI_NUMERICSERV);
		fprintf(stderr, "Send by UDP:%s %s Size:%d ", szAddr, szPort, iSendSize);

		if (sendto(m_pConInfo->fdUDP, pcData, iSendSize, 0, (sockaddr*)&m_PeerAddr, m_iPeerAddrLen) != iSendSize)
		{
			DispNetErrorMsg("Err:sendto");
			fRet = FALSE;
		}
		SAFE_FREE(pcData)
		// MƎ񑗐M܂ł̎ԂZbg
		m_dwPrevSentTimeUDP = dwNow;
		m_iSendIntervalUDP = CalcNextSendInterval(iSendSize);
	}
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̉
// parameter
//		int		iTcpUdp		[in]TRANS_METHOD_TCP/TRANS_METHOD_UDP
// retun
//		0:pPbgĂȂ
//		1:pPbgM̂ŏs
//		-1:G[
//----------------------------------------------
int CSendRecvThread::AnalyzeRecvData(int iTcpUdp)
{
	int			iRet = 0;
	HeaderRec	Header;
	WORD		wCmd, wDataLen;
	int			iPacketSize;
	LPBYTE		pbPacketData = NULL;
	CRingBuff	*pCRingBuff = (iTcpUdp == TRANS_METHOD_UDP) ? m_pCRingBuffRecvUDP : m_pCRingBuffRecv;
	int			iSize = pCRingBuff->GetReadableSize();

	if (iSize < sizeof(HeaderRec))			// wb_TCYɖȂƂ͉Ȃ
		goto L_END;
	// wb_؂ǂݍ݂
	pCRingBuff->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
	// wb_̉
	if (memcmp(Header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING)) != 0)
	{
		iRet = -1;							// ʎqႤ̂ŃG[
		goto L_END;
	}
	wCmd = ntohs(Header.wCommand);			// ntohs lbgI[_[zXgI[_[ɕϊ
	wDataLen = ntohs(Header.wDataLen);
	iPacketSize = sizeof(Header) + wDataLen;
	if (iSize < iPacketSize)				// pPbgTCYɖȂƂ͉Ȃ
		goto L_END;
	// pPbg̃f[^o
	pbPacketData = (LPBYTE)calloc(iPacketSize, sizeof(BYTE));
	pCRingBuff->ReadWithoutUpdateHeadPoint(pbPacketData, iPacketSize);

	switch (wCmd)
	{
		case CMD_MSG_DATA: 					// bZ[WpPbgɑ΂鏈s
			iRet = SetMessagePacket(pbPacketData, iPacketSize);
			break;
		case CMD_SEND_FILE_START_RES:		// Jnvɑ΂鉞
		case CMD_SEND_FILE_END_RES:			// vɑ΂鉞
		case CMD_SEND_FILE_ABORT_RES:		// fvɑ΂鉞(ING pPbgMŃG[N)
			iRet = SetSendFilePacket(pbPacketData, iPacketSize);
			break;
		case CMD_RECV_FILE_SIZE_RES:	// MTCYvɑ΂鉞
		case CMD_RECV_FILE_ABORT_RES:	// fvɑ΂鉞
		case CMD_RECV_FILE_ING:			// t@CM
		case CMD_RECV_FILE_END_REQ:		// Mv
			iRet = SetRecvFilePacket(pbPacketData, iPacketSize);
			break;
		case CTRL_TRANS_METHOD_RES:			// f[^M@
			if (iTcpUdp == TRANS_METHOD_TCP)// TCP̂
				iRet = SetTransMethodPacket(pbPacketData, iPacketSize);
			else
				iRet = -1;
			break;
		case CTRL_SEND_NAT_TRANS_RES:		// Ȃ
			iRet = 1;
			break;
		default:							// mȂR}hȂ̂ŃG[
			iRet = -1;
			break;
	}
	SAFE_FREE(pbPacketData)
	if (iRet == 1)
		pCRingBuff->UpdateHeadPoint(iPacketSize);
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//    `bgpPbg̏
//	  bZ[W̕\
// parameter
//    LPBYTE pbPacketData	[in]`bgpPbg
//	  int iPacketSize		[in]pPbgTCY
// return
//    1: -1:G[
//----------------------------------------------
int CSendRecvThread::SetMessagePacket(LPBYTE pbPacketData, int iPacketSize)
{
	int	iRet = 1;
	MsgDataRec* pmsgData = (MsgDataRec*)pbPacketData;
	int			iDestSize;
	LPBYTE		pbDest = NULL, pbDestName = NULL;
	int			iDataSize = iPacketSize - sizeof(HeaderRec);
	int			iMsgSize = iDataSize - sizeof(UserInfoRec);
	LPBYTE		pbMsg = (LPBYTE)calloc(iMsgSize + 1, sizeof(BYTE));

	// [US-JISɕϊpbDestNameɊi[
	ConvUtf8toSJis((LPBYTE)pmsgData->UserInfo.szUserName, NULL, &iDestSize);
	pbDestName = (LPBYTE)calloc(iDestSize, sizeof(BYTE));
	ConvUtf8toSJis((LPBYTE)pmsgData->UserInfo.szUserName, pbDestName, &iDestSize);

	// pmsgData->bMsgData ɁAUTF-8Ŋi[Ă(NULL^[~l[gȂ)
	memcpy(pbMsg, pmsgData->bMsgData, iMsgSize);
	// pbMsg ɁAUTF-8Ŋi[Ă(NULL^[~l[g)
	// S-JISւ̕ϊ1(Kvȃobt@TCY߂)
	ConvUtf8toSJis((LPBYTE)pbMsg, NULL, &iDestSize);
	if (iDestSize > 0)
	{
		pbDest = (LPBYTE)calloc(iDestSize, sizeof(BYTE));
		// S-JISւ̕ϊ2(ۂ̕ϊ)
		ConvUtf8toSJis((LPBYTE)pbMsg, pbDest, &iDestSize);
		// S-JIS̕\
		fprintf(stdout, "%s:%s\n", (char*)pbDestName, (char*)pbDest);	// Mf[^̕\
		fflush(stdout);
		SAFE_FREE(pbDest)
		SAFE_FREE(pbMsg)
	}
	SAFE_FREE(pbDestName)
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMR}hpPbgt@CMXbhɓn
// parameter
//		LPBYTE	pbPacketData	[in]bZ[WpPbg
//		int		iPacketSize		[in]pPbgTCY
// retun
//		1/0
//----------------------------------------------
int CSendRecvThread::SetSendFilePacket(LPBYTE pbPacketData, int iPacketSize)
{
	int	iRet = 0;

	if (m_pCSendFileThread == NULL)
		iRet = 1;
	else if (m_pCSendFileThread->m_pCQueingArrayCmd->CheckEnablePush() == TRUE)
	{
		m_pCSendFileThread->m_pCQueingArrayCmd->PushData(pbPacketData, iPacketSize);
		iRet = 1;
	}
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMR}hpPbgt@CMXbhɓn
// parameter
//		LPBYTE	pbPacketData	[in]bZ[WpPbg
//		int		iPacketSize		[in]pPbgTCY
// retun
//		1/0
//----------------------------------------------
int CSendRecvThread::SetRecvFilePacket(LPBYTE pbPacketData, int iPacketSize)
{
	int	iRet = 0;

	if (m_pCRecvFileThread == NULL)
		iRet = 1;
	else if (m_pCRecvFileThread->m_pCQueingArrayCmd->CheckEnablePush() == TRUE)
	{
		m_pCRecvFileThread->m_pCQueingArrayCmd->PushData(pbPacketData, iPacketSize);
		iRet = 1;
	}
	return(iRet);
}

//----------------------------------------------
// function
//		f[^]@̎M
// parameter
//		LPBYTE	pbPacketData	[in]bZ[WpPbg
//		int		iPacketSize		[in]pPbgTCY
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetTransMethodPacket(LPBYTE pbPacketData, int iPacketSize)
{
	BOOL				fRet = FALSE;
	TransMethodReqRec	*pTransMethod;

	pTransMethod = (TransMethodReqRec*)pbPacketData;
	m_pConInfo->bMethod = pTransMethod->TansMethodInfo.bMethod;
	fprintf(stderr, "TransMethod:%s %d\n", (m_pConInfo->bMethod == TRANS_METHOD_UDP) ? "UDP" : "TCP", ntohs(pTransMethod->TansMethodInfo.wUDPSrcPort));
	// UDPʐMpɑsockaddr 
	if (m_pConInfo->bMethod == TRANS_METHOD_UDP)			// UDP
		m_pConInfo->bMethod = MakePeerUDPSockaddr(ntohs(pTransMethod->TansMethodInfo.wUDPSrcPort));
	if (m_pConInfo->bMethod == TRANS_METHOD_TCP)			// TCP
	{
		DestroySocket(m_pConInfo->fdUDP);					// UDPŗvĂj
	}
	fRet = TRUE;
	return(fRet);
}

//----------------------------------------------
// function
//		UDPʐMpɑsockaddr 
//		m_PeerAddr̃|[gԍύX
// parameter
//		WORD wPeerPort	[in]|[g
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::MakePeerUDPSockaddr(WORD wPeerPort)
{
	BOOL		fRet = FALSE;
	char        szAddr[NI_MAXHOST], szPort[NI_MAXSERV];
	addrinfo	hints, * pres = NULL;

	getnameinfo((sockaddr*)&m_PeerAddr, m_iPeerAddrLen, szAddr, sizeof(szAddr), NULL, 0, NI_NUMERICHOST);
	DISABLE_C4996
	sprintf(szPort, "%d", wPeerPort);	// |[gԍ
	ENABLE_C4996
	memset(&hints, 0, sizeof(hints));
	if (getaddrinfo(szAddr, szPort, &hints, &pres) == 0)
	{
		memcpy(&m_PeerAddr, pres->ai_addr, pres->ai_addrlen);
		m_iPeerAddrLen = (socklen_t)pres->ai_addrlen;
		freeaddrinfo(pres);
		fRet = TRUE;
	}
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̊i[(TCP/UDP؂ւΉ)
//		Rg[pɋITCPőM@\ǉ
// parameter
//		char	*pcData		[in]Mf[^
//		int		iSize		[in]f[^
//		BOOL	fForceTCP	[in]]@ɈˑTCPg
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetSendData(char *pcData, int iSize, BOOL fForceTCP)
{
	BOOL			fRet = FALSE;
	CQueingArray	*pCQueingArray = ((fForceTCP == FALSE) && (m_pConInfo->bMethod == TRANS_METHOD_UDP)) ? m_pCQueingArraySendUDP : m_pCQueingArraySend;

	if (m_pCMySyncObjectSendWrite != NULL)
		m_pCMySyncObjectSendWrite->Lock();
	if (pCQueingArray->CheckEnablePush() == FALSE)
		goto L_END;
	pCQueingArray->PushData((LPBYTE)pcData, iSize);
	fRet = TRUE;

L_END:
	if (m_pCMySyncObjectSendWrite != NULL)
		m_pCMySyncObjectSendWrite->UnLock();
	return(fRet);
}

//----------------------------------------------
// function
//		ML[f[^o(TCP/UDP؂ւΉ)
// parameter
//		char	**ppcData	[in/out]Mf[^
//		int		iTcpUdp		[in] TRANS_METHOD_TCP/TRANS_METHOD_UDP
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetSendData(char** ppcData, int iTcpUdp)
{
	int				iSize = 0;
	CQueingArray	*pCQueingArray = (iTcpUdp == TRANS_METHOD_UDP) ? m_pCQueingArraySendUDP : m_pCQueingArraySend;

	if(pCQueingArray->GetSize() > 0)
		pCQueingArray->PopData((LPBYTE *)ppcData, &iSize);
	return(iSize);
}

//----------------------------------------------
// function
//		Mf[^̐ݒ(TCP/UDP؂ւΉ)
// parameter
//		char		*pcData	[in]Mf[^
//		int			iSize	[in]f[^
//		int			iTcpUdp	[in] TRANS_METHOD_TCP/TRANS_METHOD_UDP
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetRecvData(char* pcData, int iSize, int iTcpUdp)
{
	BOOL	fRet = FALSE;
	CRingBuff	*pCRingBuff = (iTcpUdp == TRANS_METHOD_UDP) ? m_pCRingBuffRecvUDP : m_pCRingBuffRecv;

	if (pCRingBuff->GetWriteableSize() < iSize)
		goto L_END;
	pCRingBuff->Write((LPBYTE)pcData, iSize);
	fRet = TRUE;

L_END:
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̎擾
// parameter
//		char **ppcData	[in/out]Mf[^
//		int	iTcpUdp		[in] TRANS_METHOD_TCP/TRANS_METHOD_UDP
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetRecvData(char** ppcData, int iTcpUdp)
{
	CRingBuff* pCRingBuff = (iTcpUdp == TRANS_METHOD_UDP) ? m_pCRingBuffRecvUDP : m_pCRingBuffRecv;
	// Oobt@Ɋi[ĂTCY𒲂ׂ
	int		iSize = pCRingBuff->GetReadableSize();

	if (iSize > 0)
	{
		*ppcData = (char*)calloc(iSize, sizeof(char));
		pCRingBuff->Read((LPBYTE)*ppcData, iSize);
	}
	return(iSize);
}

//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CSendRecvThread::IsZombie()
{
	BOOL	fRet;

	fRet = m_fIamZombie;
	return(fRet);
}


//----------------------------------------------
// function
//		t@CM̎{ main()Ă΂
// parameter
//		LPSTR	pszFileName	[in]t@C S-JIS
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SendFile(LPSTR pszFileName)
{
	BOOL		fRet = FALSE;

	// t@CMXbhLȎ(M)͑MJnȂ
	if (m_pCSendFileThread != NULL)
	{
		fprintf(stderr, "t@CM@t@CM܂ő҂Ă\n");
		goto L_END;
	}
	m_pCSendFileThread = new CSendFileThread(this, pszFileName);
	m_pCSendFileThread->Begin();
	fRet = TRUE;
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//		t@CM̒f
// parameter
//		Ȃ
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SendFileAbort()
{
	BOOL		fRet = FALSE;

	if (m_pCSendFileThread == NULL)
		goto L_END;

	m_pCSendFileThread->SendFileAbort();
	fRet = TRUE;
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//		t@CM̎{
// parameter
//		LPSTR	pszFileName	[in]t@C
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::RecvFile(LPSTR pszFileName)
{
	BOOL		fRet = FALSE;

	// t@CMXbhLȎ(M)͎MJnȂ
	if (m_pCRecvFileThread != NULL)
	{
		fprintf(stderr, "t@CM@t@CM܂ő҂Ă\n");
		goto L_END;
	}
	m_pCRecvFileThread = new CRecvFileThread(this, pszFileName);
	m_pCRecvFileThread->Begin();
	fRet = TRUE;
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//		t@CM̒f
// parameter
//		Ȃ
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::RecvFileAbort()
{
	BOOL		fRet = FALSE;

	if (m_pCRecvFileThread == NULL)
		goto L_END;

	m_pCRecvFileThread->RecvFileAbort();
	fRet = TRUE;
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//	t@CMς݂CSendFileThreadj
// parameter
//	Ȃ
// return
//	TRUE:j/FALSE:ĵׂȂ
//----------------------------------------------
BOOL CSendRecvThread::KillSendFileThread()
{
	BOOL	fRet = FALSE;

	if (m_pCSendFileThread != NULL)
	{
		if (m_pCSendFileThread->IsZombie() == TRUE)
		{
			m_pCSendFileThread->End();
			m_pCSendFileThread->WaitForEnd();
			SAFE_DELETE(m_pCSendFileThread)
			fRet = TRUE;
		}
	}
	return(fRet);
}

//----------------------------------------------
// function
//	t@CMς݂CRecvFileThreadj
// parameter
//	Ȃ
// return
//	TRUE:j/FALSE:ĵׂȂ
//----------------------------------------------
BOOL CSendRecvThread::KillRecvFileThread()
{
	BOOL	fRet = FALSE;

	if (m_pCRecvFileThread != NULL)
	{
		if (m_pCRecvFileThread->IsZombie() == TRUE)
		{
			m_pCRecvFileThread->End();
			m_pCRecvFileThread->WaitForEnd();
			SAFE_DELETE(m_pCRecvFileThread)
			fRet = TRUE;
		}
	}
	return(fRet);
}

//----------------------------------------------
// function
//		̑M܂ł̊Ԋu(msec)߂
// parameter
//		int iSentSize	[in]MoCg
// return
//		msec
//----------------------------------------------
int CSendRecvThread::CalcNextSendInterval(int iSentSize)
{
	int		iInterval = 0;
	double	dbBytePerSec = SEND_BPS / 8.0;
	double	dbCountPerSec;

	if (iSentSize == 0)
		goto L_END;
	dbCountPerSec = dbBytePerSec / (double)iSentSize;
	iInterval = int(1000.0 / dbCountPerSec);

L_END:
	return(iInterval);
}

//----------------------------------------------
// function
//		M\
//		TCP/UDPŎQƕϐ؂ւ
// parameter
//		DWORD	dwNow		[in]ݎ
//		int		iTcpUdp		[in]TRANS_METHOD_TCP/TRANS_METHOD_UDP 
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::CanSendNow(DWORD dwNow, int iTcpUdp)
{
	BOOL	fRet = FALSE;
	DWORD	dwPrevSentTime = (iTcpUdp == TRANS_METHOD_UDP) ? m_dwPrevSentTimeUDP : m_dwPrevSentTime;
	int		iSendInterval = (iTcpUdp == TRANS_METHOD_UDP) ? m_iSendIntervalUDP : m_iSendInterval;

	if (GetdwInterval(dwNow, dwPrevSentTime) >= (DWORD)iSendInterval)
		fRet = TRUE;

	return(fRet);
}

