#include	"stdThread.h"

#define	STATUS_MSG_WIN_TOP		15
#define	STATUS_MSG_WIN_BUTTOM	25

#define	USER_MSG_WIN_TOP		3
#define	USER_MSG_WIN_BUTTOM		14

BOOL	gfEnableESC = FALSE;
int		giStatusMsgRow = STATUS_MSG_WIN_TOP;
int		giUserMsgRow = USER_MSG_WIN_TOP;

//-----------------------------------------------------------------
// Function
//		dwNow  dwPast ̊Ԃ̌o߂߂
// Parameter
//		Ȃ
// Return
//		o
//-----------------------------------------------------------------
DWORD GetdwInterval(DWORD dwNow, DWORD dwPast)
{
	DWORD	dwInterval;

	if (dwNow >= dwPast)
		dwInterval = dwNow - dwPast;
	else
		dwInterval = dwNow + ((DWORD)(-1) - dwPast);
	return(dwInterval);
}

//-----------------------------------------------------------------
// Function
//		R[hϊ
//		UTF-8 -> UTF-16 -> SJIS
//		pbDestNULL̎AϊɕKvȃTCYԂ
//		pbDestNULLłȂAϊ̒̕Ԃ
// Parameter
//		BYTE	*pbSource	[in]ϊOUTF-8
//		BYTE	*pbDest		[in/out]ϊSJIS
//		int		*piSize		[in/out]pbDest̕KvTCY/̒
// Return
//		o
//-----------------------------------------------------------------
BOOL ConvUtf8toSJis(BYTE *pbSource, BYTE *pbDest, int *piSize)
{
	int		iSize, iSizeSJis;
	LPBYTE	pbBuffUtf16 = NULL, pbBuffSJis = NULL;

	*piSize = 0;
	//UTF-8 -> UTF-16
	iSize = ::MultiByteToWideChar(CP_UTF8, 0, (LPCSTR)pbSource, -1, NULL, 0);
	pbBuffUtf16 = (LPBYTE)calloc(iSize * 2, sizeof(BYTE));
	::MultiByteToWideChar(CP_UTF8, 0, (LPCSTR)pbSource, -1, (LPWSTR)pbBuffUtf16, iSize);
	//UTF-16 -> SJIS
	iSizeSJis = ::WideCharToMultiByte(CP_ACP, 0, (LPCWSTR)pbBuffUtf16, -1, NULL, 0, NULL, NULL);
	if (pbDest == NULL)
	{
		*piSize = iSizeSJis;
		goto L_END;
	}
	pbBuffSJis = (LPBYTE)calloc(iSizeSJis, sizeof(BYTE));
	::WideCharToMultiByte(CP_ACP, 0, (LPCWSTR)pbBuffUtf16, -1, (LPSTR)pbBuffSJis, iSizeSJis, NULL, NULL);
	*piSize = (int)strlen((char*)pbBuffSJis);
	memcpy(pbDest, pbBuffSJis, *piSize);

L_END:
	SAFE_FREE(pbBuffUtf16)
	SAFE_FREE(pbBuffSJis)
	return(TRUE);
}

//-----------------------------------------------------------------
// Function
//		R[hϊ
//		SJIS -> UTF-16 ->UTF-8
//		pbDestNULL̎AϊɕKvȃTCYԂ
//		pbDestNULLłȂAϊ̒̕Ԃ
// Parameter
//		BYTE	*pbSource	[in]ϊOSJIS
//		BYTE	*pbDest		[in/out]ϊUTF-8
//		int		*piSize		[in/out]pbDest̕KvTCY
// Return
//		o
//-----------------------------------------------------------------
BOOL ConvSJistoUtf8(LPBYTE pbSource, LPBYTE pbDest, int *piSize)
{
	int		iSize, iSizeUtf8;
	LPBYTE	pbBuffUtf16 = NULL, pbBuffUtf8 = NULL;

	*piSize = 0;
	//SJIS -> UTF-16
	iSize = ::MultiByteToWideChar(CP_ACP, 0, (LPCSTR)pbSource, -1, NULL, 0);
	pbBuffUtf16 = (LPBYTE)calloc(iSize * 2, sizeof(BYTE));
	::MultiByteToWideChar(CP_ACP, 0, (LPCSTR)pbSource, -1, (LPWSTR)pbBuffUtf16, iSize);
	//UTF-16 -> UTF-8
	iSizeUtf8 = ::WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)pbBuffUtf16, -1, NULL, 0, NULL, NULL);
	if (pbDest == NULL)
	{
		*piSize = iSizeUtf8;
		goto L_END;
	}
	pbBuffUtf8 = (LPBYTE)calloc(iSizeUtf8, sizeof(BYTE));
	WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)pbBuffUtf16, -1, (LPSTR)pbBuffUtf8, iSizeUtf8, NULL, NULL);
	*piSize = (int)strlen((char*)pbBuffUtf8);
	memcpy(pbDest, pbBuffUtf8, *piSize);
L_END:
	SAFE_FREE(pbBuffUtf16)
	SAFE_FREE(pbBuffUtf8)
	return(TRUE);
}


#ifdef _NETWORK_APP
//----------------------------------------------
// function
//		G[R[hƃG[bZ[W\܂
// parameter
//		LPCSTR pszTitle	[in]bZ[Wɂ^Cg
// return
//		G[R[h
//----------------------------------------------
int DispNetErrorMsg(LPCSTR pszTitle)
{
	LPVOID	lpMsgBuf;
	int		iErr = WSAGetLastError();

	FormatMessage(				//G[\쐬
		FORMAT_MESSAGE_ALLOCATE_BUFFER |			// eLXg̃蓖Ăv
		FORMAT_MESSAGE_FROM_SYSTEM |				// G[bZ[WWindowspӂĂ̂gp
		FORMAT_MESSAGE_IGNORE_INSERTS,				// ̈𖳎ăG[R[hɑ΂G[bZ[W쐬
		NULL,
		iErr,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),	// w
		(LPTSTR)&lpMsgBuf, 0, NULL);

	DispStatusMsg(stderr, "%s %d %s", pszTitle, WSAGetLastError(), (LPSTR)lpMsgBuf);
	LocalFree(lpMsgBuf);
	return(iErr);
}
#endif

//----------------------------------------------------------------------
// function
//		ESCV[PXɂʐLɂ
// parameter
//		FILE		*stream		[in]Lɂt@CXg[
// return
//		TRUE/FALSE
//----------------------------------------------------------------------
BOOL EnableESC(FILE* stream)
{
	HANDLE	handle = (HANDLE)_get_osfhandle(_fileno(stream));
	DWORD	dwMode = 0;
	BOOL	fRet = FALSE;

	if (!GetConsoleMode(handle, &dwMode))
		goto L_END;

	if (!SetConsoleMode(handle, dwMode | ENABLE_VIRTUAL_TERMINAL_PROCESSING))
		goto L_END;

	fRet = TRUE;
	gfEnableESC = fRet;

L_END:
	return(fRet);
}

//----------------------------------------------------------------------
// function
//		ESCV[PXɂJ[\ړ
// parameter
//		FILE	*stream		[in]o͐
//		int		iCol		[in]
//		int		iRow		[in]s
//		int		iErase		[in]0:Ȃ 1:s܂ŏ 2:Ō܂ŏ
// return
//		TRUE/FALSE
//----------------------------------------------------------------------
void Locate(FILE* stream, int iCol, int iRow, int iErase)
{
	if (gfEnableESC == FALSE)
		return;
	switch (iErase)
	{
	case 1:
		fprintf(stream, "\x1b[%d;%dH\x1b[0K", iRow, iCol);
		break;
	case 2:
		fprintf(stream, "\x1b[%d;%dH\x1b[0J", iRow, iCol);
	default:
		fprintf(stream, "\x1b[%d;%dH", iRow, iCol);
		break;
	}
}

//----------------------------------------------------------------------
// function
//		Ԃ\bZ[W̕\
// parameter
//		FILE	*stream			[in]o͐
//		LPCSTR	pszStatusMsg	[in]Ԃ\bZ[W
// return
//		Ȃ
//----------------------------------------------------------------------
void DispStatusMsg(FILE* stream, LPCSTR pszStatusMsg, ...)
{
	va_list args;

	va_start(args, pszStatusMsg);

	Locate(stream, 1, giStatusMsgRow++, 1);
	if (giStatusMsgRow == STATUS_MSG_WIN_BUTTOM)
		giStatusMsgRow = STATUS_MSG_WIN_TOP;
	vfprintf(stream, pszStatusMsg, args);
	if (gfEnableESC == FALSE)
		fprintf(stream, "\n");
	fflush(stream);
	va_end(args);
}

//----------------------------------------------------------------------
// function
//		[Uɑ΂郁bZ[W̕\
// parameter
//		FILE	*stream		[in]o͐
//		LPCSTR	pszUserMsg	[in][Uɑ΂郁bZ[W̕\
// return
//		Ȃ
//----------------------------------------------------------------------
void DispUserMsg(FILE* stream, LPCSTR pszUserMsg, ...)
{
	va_list args;

	Locate(stream, 1, giUserMsgRow++, 1);
	if (giUserMsgRow == USER_MSG_WIN_BUTTOM)
		giUserMsgRow = USER_MSG_WIN_TOP;

	va_start(args, pszUserMsg);

	vfprintf(stream, pszUserMsg, args);
	if (gfEnableESC == FALSE)
		fprintf(stream, "\n");
	fflush(stream);
	va_end(args);
}
