#ifndef _stdThread_H_2B9D23FC_90BF_4898_B161_B894F01F6698
#define _stdThread_H_2B9D23FC_90BF_4898_B161_B894F01F6698

#define _NETWORK_APP				// @Network֘ALɂ

#include	<stdio.h>
#include	<process.h>
#ifdef _NETWORK_APP
#include	<winsock2.h>
#include	<iphlpapi.h>
#include	<Ws2tcpip.h>
#else
#include	<windows.h>
#endif

#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>


//------------------------------------------------------------------------
// [Nop
#define _CRTDBG_MAP_ALLOC
#include <cstdlib>
#include <crtdbg.h>

#ifdef _DEBUG
#define new ::new(_NORMAL_BLOCK, __FILE__, __LINE__)				// 
#else
#define DBG_NEW new
#endif
//------------------------------------------------------------------------

#ifdef _NETWORK_APP
#pragma	comment(lib, "iphlpapi.lib")
#pragma	comment(lib, "Ws2_32.lib")
#endif
#pragma	comment(lib, "Winmm.lib")

//-----------------------------------------------------------------------
#define SAFE_FREE(p)	{ if(p) { free(p); (p)=NULL; } }
#define SAFE_DELETE(p)  { if(p) { delete (p);     (p)=NULL; } }
#define SAFE_DELETE_ARRAY(p)  { if(p) { delete[] (p); (p)=NULL; } }
//-----------------------------------------------------------------------
#ifdef _MSC_VER			// WindowŝƂ
#define DISABLE_C4996   __pragma(warning(push)) __pragma(warning(disable:4996))
#define ENABLE_C4996    __pragma(warning(pop))
#else					// Linux̂Ƃ
#define DISABLE_C4996
#define ENABLE_C4996
#endif


extern BOOL	gfEnableESC;

extern DWORD GetdwInterval(DWORD dwNow, DWORD dwPast);
extern BOOL ConvUtf8toSJis(BYTE* pSource, BYTE* pDist, int* pSize);
extern BOOL ConvSJistoUtf8(LPBYTE pbSource, LPBYTE pbDest, int *piSize);
#ifdef _NETWORK_APP
extern int DispNetErrorMsg(LPCSTR pszTitle);
#endif
extern BOOL EnableESC(FILE* stream);
extern void Locate(FILE* stream, int iCol, int iRow, int iErase);
extern void DispStatusMsg(FILE* stream, LPCSTR pszStatus, ...);
extern void DispUserMsg(FILE* stream, LPCSTR pszUserMsg, ...);

#endif

